package Agents;
import java.util.Random;
import java.util.Vector;

import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.OneShotBehaviour;
import jade.core.behaviours.SequentialBehaviour;
import jade.core.behaviours.WakerBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import message.*;

public class PartyGuest extends Agent {

	private AID hostName;
	private Vector<String> lista_invitados = new Vector<String>();
	private Random rand = new Random();
	private int comida = 0;
	private int bebida = 0;

	protected void setup(){

		// Descripción del agente
		DFAgentDescription descripcion = new DFAgentDescription();
		descripcion.setName(getAID());

		// Descripcion de un servicio se proporciona
		ServiceDescription servicio = new ServiceDescription();
		servicio.setType("Invitado");
		servicio.setName("Invitado");

		// Añade dicho servicio a la lista de servicios de la descripción del agente
		descripcion.addServices(servicio);

		try
		{
			DFService.register(this, descripcion);
		}
		catch (FIPAException e)
		{
			e.printStackTrace();
		}

		ServiceDescription servicio_de_busqueda= new ServiceDescription();
		servicio_de_busqueda.setType("Anfitrion");

		// Servicio que busca el agente
		DFAgentDescription descripcion_de_busqueda = new DFAgentDescription();
		descripcion_de_busqueda.addServices(servicio_de_busqueda);
		try
		{
			// Todas las descripciones que encajan con la plantilla proporcionada en el DF
			DFAgentDescription[] resultados = DFService.search(this,descripcion_de_busqueda);

			if (resultados.length == 0)
				System.out.println("Ningun agente ofrece el servicio deseado");
			else
				hostName = resultados[0].getName();

		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		SequentialBehaviour seq = new SequentialBehaviour();
		CyclicBehaviour cyc = new CyclicBehaviour(){


			@Override
			public void action() {
				ACLMessage aids = myAgent.receive(MessageTemplate.MatchPerformative(ACLMessage.INFORM));

				if(aids!=null){
					if(!aids.getContent().equals("no_hay") ){
						lista_invitados.add(aids.getContent());
						System.out.println("\t"+"'"+myAgent.getLocalName()+"' saluda a "+ aids.getContent());
						messageSystem.greetTo(myAgent,aids.getContent());
						ACLMessage agr = myAgent.blockingReceive(MessageTemplate.MatchPerformative(ACLMessage.AGREE));
						System.out.println(myAgent.getLocalName()+ ": " + agr.getSender().getLocalName()+" me ha devuelto saludo");


					}else{
						System.out.println(myAgent.getLocalName() + ":  Esperare pues...");
					}
				}else{
					block();
				}

			}

		};

		// SUB behaviour para venir cuando le de la gana
		seq.addSubBehaviour( new WakerBehaviour(this, rand.nextInt(20) * 1000)
		{

			@Override
			public void onWake() {
				System.out.println(myAgent.getLocalName() + " pide entrar al " + hostName.getLocalName());
				messageSystem.sendTo(myAgent, "Puedo_entrar", hostName.getLocalName());
			}
		});

		// SUB behaviour para recivir confirmacion y los invitados que han llegado a la fiesta
		seq.addSubBehaviour(new Behaviour(this){
			int step = 1;
			public void onStart() {
				System.out.println(myAgent.getLocalName() + " espera respuesta del " + hostName.getLocalName());
			}
			public void action(){

				//Comunicacion

				switch (step)
				{
				case 1:
					ACLMessage msg = myAgent.blockingReceive(MessageTemplate.MatchPerformative(ACLMessage.CONFIRM));
					break;
				case 2: // Si un invitado le pide entrar en la fiesta
					System.out.println("\t'"+myAgent.getLocalName() + "'Ha entrado en la fiesta'");
					addBehaviour(cyc);
					break;
				}
				step++;
			}

			@Override
			public boolean done() {
				// TODO Auto-generated method stub
				return step == 3;
			}
		});


		addBehaviour(seq);



		addBehaviour(new CyclicBehaviour(){

			@Override
			public void action() {
				ACLMessage waiterMsg = myAgent.receive(MessageTemplate.MatchPerformative(ACLMessage.PROPOSE));
				if(waiterMsg != null){
					if(isSatisfied(comida) && isSatisfied(bebida)){
						messageSystem.serveMe(myAgent, "satisfecho", waiterMsg.getSender().getLocalName());
						System.out.println(myAgent.getLocalName() + ": Estoy totalmente satisfecho");
						System.out.println(myAgent.getLocalName() + ": Me voy, me lo he pasado de **** madre");
						messageSystem.sendTo(myAgent, "despedirse", hostName.getLocalName());						
						myAgent.doDelete();
					}else{
						switch(rand.nextInt(2)){
						case 0:
							if(isSatisfied(bebida)){
								messageSystem.serveMe(myAgent, "comida", waiterMsg.getSender().getLocalName());
								System.out.println(myAgent.getLocalName() + ": Dame comida");
								comida = comida + 1;
							}else{
								messageSystem.serveMe(myAgent, "bebida", waiterMsg.getSender().getLocalName());
								System.out.println(myAgent.getLocalName() + ": Dame bebida");
								bebida = bebida + 1;
							}
							break;
						case 1:
							if(isSatisfied(comida)){
								messageSystem.serveMe(myAgent, "bebida", waiterMsg.getSender().getLocalName());
								System.out.println(myAgent.getLocalName() + ": Dame bebida");
								bebida = bebida + 1;

							}else{
								messageSystem.serveMe(myAgent, "comida", waiterMsg.getSender().getLocalName());
								System.out.println(myAgent.getLocalName() + ": Dame comida");
								comida = comida + 1;
							}
							break;
						}
					}
				}else{
					block();
				}
			}


		});

		// El behaviour de recivir los mensajes de anfitrion y invitados.

		addBehaviour(new CyclicBehaviour(){

			@Override
			public void action() {
				ACLMessage propMsg = myAgent.receive(MessageTemplate.MatchPerformative(ACLMessage.PROPAGATE));

				if(propMsg != null){
					removeBehaviour(cyc);
					switch(propMsg.getContent()){
					case "ok":
						System.out.println(myAgent.getLocalName()+" se ha ido de la fiesta");
						break;
					case "Hola":
						System.out.println(myAgent.getLocalName()+ ": " + propMsg.getSender().getLocalName()+" me ha saludado");
						messageSystem.greetOt(myAgent,propMsg.getSender().getLocalName());
						break;
					}
				}else{
					block();
				}

			}

		});



	}
	private boolean isSatisfied(int algo){
		return (algo == 2);
	}

}
