package Agents;

import java.util.Random;
import java.util.Vector;
import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.OneShotBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import message.messageSystem;

public class PartyHost extends Agent {

	private Vector<String> lista_invitados = new Vector<String>();
	private Vector<String> lista1 = new Vector<String>();
	private Vector<String> lista2 = new Vector<String>();
	private Vector<String> camareros = new Vector<String>();
	private int comida = 0;
	private int bebida = 0;
	private Random rand = new Random();
	private String camarero1, camarero2;

	protected void setup() {		

		// Descripcion del agente
		DFAgentDescription descripcion = new DFAgentDescription();
		descripcion.setName(getAID());

		// Descripcion de un servicio se proporciona
		ServiceDescription servicio = new ServiceDescription();
		servicio.setType("Anfitrion");
		servicio.setName("Anfitrion");

		// Anade dicho servicio a la lista de servicios de la descripcion del agente
		descripcion.addServices(servicio);

		try
		{
			DFService.register(this, descripcion);
		}
		catch (FIPAException e)
		{
			e.printStackTrace();
		}
		
		ServiceDescription servicio_de_busqueda= new ServiceDescription();
		servicio_de_busqueda.setType("Camarero");

		// Servicio que busca el agente
		DFAgentDescription descripcion_de_busqueda = new DFAgentDescription();
		descripcion_de_busqueda.addServices(servicio_de_busqueda);
		try
		{
			// Todas las descripciones que encajan con la plantilla proporcionada en el DF
			DFAgentDescription[] resultados = DFService.search(this,descripcion_de_busqueda);

			if (resultados.length == 0)
				System.out.println("Ningun agente ofrece el servicio deseado");
			else{
				for(int i = 0; i<resultados.length;i++){
					camareros.add(resultados[i].getName().getLocalName());
					
				}
			}

		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		addBehaviour(new OneShotBehaviour(this) {

			public void action() {

				System.out.println("Las puertas han abierto.");
				partyStart();

			}
		});
	}

	private void partyStart(){
		
		addBehaviour(new CyclicBehaviour(){

			@Override
			public void action() {
				ACLMessage waiterMsg = myAgent.receive(MessageTemplate.MatchPerformative(ACLMessage.PROPOSE));
				if(waiterMsg != null){
					
					if(isSatisfied(comida) && isSatisfied(bebida)){
						messageSystem.serveMe(myAgent, "satisfecho", waiterMsg.getSender().getLocalName());
						System.out.println(myAgent.getLocalName() + ": Estoy totalmente satisfecho, sirve a los invitados");
					}else{
						switch(rand.nextInt(2)){
						case 0:
							if(isSatisfied(bebida)){
								messageSystem.serveMe(myAgent, "comida", waiterMsg.getSender().getLocalName());
								System.out.println(myAgent.getLocalName() + ": Dame comida");
								comida = comida + 1;
							}else{
								messageSystem.serveMe(myAgent, "bebida", waiterMsg.getSender().getLocalName());
								System.out.println(myAgent.getLocalName() + ": Dame bebida");
								bebida = bebida + 1;
							}
							break;
						case 1:
							if(isSatisfied(comida)){
								messageSystem.serveMe(myAgent, "bebida", waiterMsg.getSender().getLocalName());
								System.out.println(myAgent.getLocalName() + ": Dame bebida");
								bebida = bebida + 1;

							}else{
								messageSystem.serveMe(myAgent, "comida", waiterMsg.getSender().getLocalName());
								System.out.println(myAgent.getLocalName() + ": Dame comida");
								comida = comida + 1;
							}
							break;
						}
					}
				}else{
					block();
				}
			}


		});

		addBehaviour(new CyclicBehaviour(this){

			public void action(){

				//Comunicacion
				ACLMessage msg = myAgent.receive(MessageTemplate.MatchPerformative(ACLMessage.INFORM));

				if (msg!= null && msg.getContent() != null)
				{
					switch (msg.getContent())
					{
					case "Puedo_entrar": // Si un invitado le pide entrar en la fiesta

						System.out.println("\t'"+ myAgent.getLocalName() + "' Devuelve saludo y deja entrar a '" + msg.getSender().getLocalName());

						messageSystem.acceptTo(myAgent, msg.getSender().getLocalName());//Le dice que si

						if(lista_invitados.size() == 0){
							System.out.println(myAgent.getLocalName()+ ": Esperemos a los demas!!");
							messageSystem.sendTo(myAgent, "no_hay", msg.getSender().getLocalName());
						}else{
							for(int i=0;i<lista_invitados.size();i++){

								if(i == 0 && i != lista_invitados.size()-1){
									System.out.print(myAgent.getLocalName()+ ": Oye!! Saluda a " +lista_invitados.get(i));
								}else if(i>0 && i != lista_invitados.size()-1){
									System.out.print(", " +lista_invitados.get(i));
								}else if(i == 0 && i == lista_invitados.size()-1){
									System.out.println(myAgent.getLocalName()+ ": Oye!! Saluda a " +lista_invitados.get(i)+ "!!");
								}else{
									System.out.println(" y a " +lista_invitados.get(i)+ "!!");
								}
								messageSystem.sendTo(myAgent, lista_invitados.get(i), msg.getSender().getLocalName());//Le dice que si
							}
						}

						lista_invitados.add(msg.getSender().getLocalName());//Anade el nuevo invitado al vector de comensales
						if(lista_invitados.size() == 10){
							System.out.println(myAgent.getLocalName() + ": Ya estan todos los invitados");
							messageSystem.sendToGroup(myAgent, "empieza", "Camarero");
							for(int i = 0; i<(lista_invitados.size()/camareros.size());i++){
								lista1.add(lista_invitados.get(i));
							}
							lista1.add(myAgent.getLocalName());
							messageSystem.start(myAgent, lista1, camareros.get(0));
							for(int i = (lista_invitados.size()/camareros.size()); i<(lista_invitados.size());i++){
								lista2.add(lista_invitados.get(i));
							}
							messageSystem.start(myAgent, lista2, camareros.get(1));
						}

						break;

					case "despedirse": //se despide del invitado que se despide de el
						System.out.println(myAgent.getLocalName()+ ": Adios " + msg.getSender().getLocalName()+", te espero para la siguiente");
						lista_invitados.removeElement(msg.getSender().getLocalName());
						if(lista_invitados.size()==0){
							System.out.println(myAgent.getLocalName()+ ": Estoy solo asi que ha terminado la fiesta");
						}
						break;

					}
				}else{
					block();
				}
			}
		});
	}

	
	
	private boolean isSatisfied(int algo){
		return (algo == 2);
	}
}
