package Agents;
import java.io.IOException;
import java.util.Random;
import java.util.Vector;

import jade.core.AID;
import jade.core.Agent;
import jade.core.behaviours.CyclicBehaviour;
import jade.core.behaviours.OneShotBehaviour;
import jade.core.behaviours.TickerBehaviour;
import jade.core.behaviours.WakerBehaviour;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;
import jade.lang.acl.ACLMessage;
import jade.lang.acl.MessageTemplate;
import jade.lang.acl.UnreadableException;
import message.messageSystem;

public class PartyWaiter extends Agent{

	/**
	 * 
	 */

	private Vector<String> lista = new Vector<String>();

	protected void setup() {

		// Descripción del agente
		DFAgentDescription descripcion = new DFAgentDescription();
		descripcion.setName(getAID());

		// Descripcion de un servicio se proporciona
		ServiceDescription servicio = new ServiceDescription();
		servicio.setType("Camarero");
		servicio.setName("Camarero");

		// Añade dicho servicio a la lista de servicios de la descripción del agente
		descripcion.addServices(servicio);

		try
		{
			DFService.register(this, descripcion);
		}
		catch (FIPAException e)
		{
			e.printStackTrace();
		}

		ServiceDescription servicio_de_busqueda1= new ServiceDescription();
		servicio_de_busqueda1.setType("Anfitrion");
		ServiceDescription servicio_de_busqueda2= new ServiceDescription();
		servicio_de_busqueda2.setType("Invitado");

		// Servicio que busca el agente
		DFAgentDescription descripcion_de_busqueda1 = new DFAgentDescription();
		descripcion_de_busqueda1.addServices(servicio_de_busqueda1);
		DFAgentDescription descripcion_de_busqueda2 = new DFAgentDescription();
		descripcion_de_busqueda2.addServices(servicio_de_busqueda2);
		try
		{
			// Todas las descripciones que encajan con la plantilla proporcionada en el DF
			DFAgentDescription[] resultados1 = DFService.search(this,descripcion_de_busqueda1);
			DFAgentDescription[] resultados2 = DFService.search(this,descripcion_de_busqueda2);

			if (resultados1.length == 0)
				System.out.println("Ningun agente ofrece el servicio deseado");
			else
				lista.add(resultados1[0].getName().getLocalName());

			for(int i=0;i<resultados2.length;i++ ){
				lista.add(resultados2[i].getName().getLocalName());
			}

		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		
		
		CyclicBehaviour cyc1= new CyclicBehaviour(this){

			@Override
			public void action() {
				Random rand = new Random();
				String client = lista.get(rand.nextInt(lista.size()));
				messageSystem.proposeTo(myAgent, client);
				System.out.println("\t'"+myAgent.getLocalName() + "'ofrece sus servicios '" + client);
				ACLMessage prop = myAgent.blockingReceive(MessageTemplate.MatchPerformative(ACLMessage.ACCEPT_PROPOSAL));
				System.out.println(myAgent.getLocalName() + ": Oido cocina");
				if(prop!=null){
					switch (prop.getContent())
					{
					case "satisfecho":
						lista.removeElement(prop.getSender().getLocalName());
						if(lista.size() == 0){
							System.out.println(myAgent.getLocalName() + ": Ya no trabajo mas");
							myAgent.doDelete();
						}					
						break;
					case "bebida": // Si un invitado le pide entrar en la fiesta
						System.out.println("\t'"+myAgent.getLocalName() + "'Sirve bebida a '" + prop.getSender().getLocalName());
						break;
					case "comida": // Si un invitado le pide entrar en la fiesta
						System.out.println("\t'"+myAgent.getLocalName() + "'Sirve comida a '" + prop.getSender().getLocalName());
						break;
					}
				}else{
					block();
				}

			}

		};
		
		addBehaviour(new OneShotBehaviour(){

			@Override
			public void action() {
				myAgent.blockingReceive(MessageTemplate.MatchPerformative(ACLMessage.PROPAGATE));
				System.out.println(myAgent.getLocalName() + ": He empezado a trabajar!!");
				ACLMessage list = myAgent.blockingReceive(MessageTemplate.MatchPerformative(ACLMessage.INFORM));
				try {
					lista = (Vector<String>) list.getContentObject();
				} catch (UnreadableException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				addBehaviour(cyc1);
			}
			
		});


		

	}

}
